# 驭码 CodeRider

[驭码 CodeRider](https://coderider.gitlab.cn/) 是[极狐GitLab](https://gitlab.cn/) 推出的基于人工智能和生成式内容技术的新一代软件生产工具，为开发者提供自然语言生成代码、代码补全、代码调优纠错、单元测试生成、代码解释以及智能技术问答等功能。CodeRider 与 GitLab 深度融合，为企业提供软件开发全生命周期（SDLC）的支持，涵盖项目快速上手、企业文档库/代码仓智能问答、议题管理、合并请求智能辅助、代码智能评审、安全扫描智能解析、流水线管理等功能。

## 快速开始 Quick Start

### 用户登录 User Login

1. 单击导航栏的驭码 CodeRider，输入驭码实例地址，并勾选相关协议后，选择登录方式。

   注：中国大陆 SaaS 用户的驭码实例地址为：https://coderider.jihulab.com （默认）。若您为私有化部署企业用户，请联系企业管理员获取驭码实例地址。

   ![登录方式选择.png](https://jihulab.com/-/project/220417/uploads/0222f6a2d9c1c0c1fcf510fd8c4133d5/%E7%99%BB%E5%BD%95%E6%96%B9%E5%BC%8F%E9%80%89%E6%8B%A9.png)

2. 登录方式一：OAuth 登录

   a. 选择 OAuth 登录方式后，打开外部授权登录网站。

   b. 在跳转的 Web 网页端点击授权 CodeRider 后再次点击打开 Visual Studio Code。

   c. 请于 1 分钟内在 Visual Studio Code 中点击允许 CodeRider 打开此 URL，之后稍等片刻即可看到登录完成的状态。

   ![OAuth_登录.png](https://jihulab.com/-/project/220417/uploads/9817cf4cc6f0a1ecb4a3018d809cbf0d/OAuth_%E7%99%BB%E5%BD%95.png)

3. 登录方式二：个人访问令牌登录

   a. 选择“个人访问令牌登录”（PAT）方式后。若您为首次使用 PAT 登录的用户，请点击“创建” PAT。若您已有 PAT，请直接跳转第 e 步。

   b. 在创建 PAT 页面，请完成以下配置：

   1. 输入“令牌名称”，默认为“CodeRider”，可无需修改。

   2. 设置 PAT 到期时间，建议取消时间限制，则有效期为一年。

   3. 选择范围勾选：api。

   c. 配置完成后，点击“创建个人访问指令”。

   d. 注意：由于无法再次访问该 PAT，请复制并妥善保存。

   e. 将创建好的 PAT 填写到对应位置，建议勾选“记住当前 PAT”以便后续登录使用，点击“登录”即可登录成功。

   ![PAT_登录.png](https://jihulab.com/-/project/220417/uploads/699ba852f07ebfc300c94a478c8ffce8/PAT_%E7%99%BB%E5%BD%95.png)

## 产品功能 Product Features

### 1. Loom
驭码CodeRider Loom 可系统化处理复杂软件开发任务，通过创建编辑文件、解析项目架构、安全访问浏览器及授权执行终端指令的全流程覆盖，提供超越传统代码补全的全栈级支持。

Loom 可与用户共同完成研发任务，开发过程中整体交互界面如下：

![Loom.png](https://jihulab.com/-/project/220417/uploads/12799f46fec15afa921fa100e0a56f70/2.0.0_Loom_%E9%9D%A2%E6%9D%BF.png)

1.1 设置工作模式
- 计划：计划模式下，Loom 将会根据需求完成任务计划。
- 执行：执行模式下，Loom 将立即完成任务。

![Loom_工作模式.png](https://jihulab.com/-/project/220417/uploads/26892aa05acaeed5d7284e22c9f6da25/v2.0.0_Loom_%E6%A8%A1%E5%BC%8F%E5%88%87%E6%8D%A2.png)

1.2 在 CodeRider 插件中打开 Loom 面板，并在输入框中描述需求。在描述需求时，可通过输入 “@” 获取内容，或者 “#” 索引文件夹、文件。
- @问题：检查当前项目中的代码或配置错误，以便于 Loom 修复。
- @终端：执行终端操作。
- @Git 提交：选择 Git 提交记录来完成操作。
- #文件夹或文件：索引文件夹或文件内容作为上下文。

![Loom_获取内容.png](https://jihulab.com/-/project/220417/uploads/2039a5346c0e41e8eff4552e899c3bba/v2.0.0_Loom%E8%BE%93%E5%85%A5%E9%9C%80%E6%B1%82.png)

1.3 输入项目需求后，Loom 将对任务进行拆解，并按步骤执行。在此过程中，Loom 将协助您安装项目运行所需的依赖环境，并将编程实现结果以 diff 的形式显示在工作区。

![Loom_执行任务.png](https://jihulab.com/-/project/220417/uploads/b70888f38cc3f579d0587afe2186b94f/v2.0.0_Loom_%E4%BB%BB%E5%8A%A1%E6%89%A7%E8%A1%8C.png)

1.4 项目代码编写完成后，保存所有代码变更并运行项目。

![Loom_运行项目.png](https://jihulab.com/-/project/220417/uploads/e64846dac05f24962826698a88ca8032/v2.0.0_Loom%E4%BB%BB%E5%8A%A1%E4%BF%9D%E5%AD%98%E4%B8%8E%E8%BF%90%E8%A1%8C.png)

### 2. 代码智能生成/补全

#### 2.1 代码智能实时补全

当您在 IDE 中编写代码时，在开启代码补全功能的情况下，CodeRider 会根据当前代码文件及相关代码文件内容自动为您实时补全代码，此时您可以使用快捷键逐片段或整个模块接纳代码建议，也可以废弃当前代码建议。

当您开启代码补全增强模式时，CodeRider 会根据您当前代码仓库内容为您推荐更符合业务场景和编程风格的代码建议。

![vs_code_代码补全.png](https://jihulab.com/-/project/220417/uploads/7863e1bdfb2f20ac8cc88e787073e4b5/vs_code_%E4%BB%A3%E7%A0%81%E8%A1%A5%E5%85%A8.png)


#### 2.2 自然语言生成代码

您可以在 IDE 中使用自然语言描述您的编程需求，CodeRider 将根据需求指令生成代码建议。

在编辑器中生成代码时，CodeRider 将参考当前代码文件、整个项目仓相关代码内容（增强模式下）自动为您生成代码。您可以使用快捷键逐片段或整个模块接纳生成代码，也可以废弃当前代码建议。（快捷键及模式设置参考“代码智能实时补全”。）

在对话框中生成代码时，您可直接输入自然语言需求，CodeRider 将生成对应代码建议。特别地，当您“@代码仓知识库”并输入需求时，CodeRider 将针对指定的代码仓内容结合需求指令生成代码。您可以点击“在光标处插入”直接将生成代码插入到光标停留位置。

![VS_code_自然语言生成代码.png](https://jihulab.com/-/project/220417/uploads/ededbf43478d536c520c91e7214534d3/VS_code_%E8%87%AA%E7%84%B6%E8%AF%AD%E8%A8%80%E7%94%9F%E6%88%90%E4%BB%A3%E7%A0%81.png)

### 3. 智能辅助编程

> 说明：CodeRider 提供代码解释、代码注释、代码修改、单元测试、代码优化功能的快捷触发方式，包含：
>
> a. 选中代码片段后，在对话界面单击对应功能快捷操作。
>
> b. 选中代码片段后，右键选择 CodeRider，并点击对应功能快捷操作。
>
> c. 选中代码片段后，在对话输入框输入“/”后选择对应的快捷操作。
>
> d. 在打开内联指令的情况下，在对应的函数片段上，点击 CodeRider 的 Logo 即可唤醒快捷操作。（可在“详细设置”中设置开启）
>
> e. 在代码编辑器中使用快捷键触发内联操作，可选择作用的代码范围并输入指令。
>
> ![VS_Code_快捷指令触发](https://jihulab.com/-/project/220417/uploads/2a0a2e3611b2e64567c6c3d243b28042/v1.7.2_VS_Code_%E5%BF%AB%E6%8D%B7%E6%8C%87%E4%BB%A4%E8%A7%A6%E5%8F%91.png)

### 3.1 项目引导

CodeRider 为项目提供快速引导功能，帮助您快速上手项目代码。

注：当前项目必须已创建为代码知识库，否则该功能无法使用。

![VS_code_Onboarding.png](https://jihulab.com/-/project/220417/uploads/99d0f454634b3c1f61583960b78bdfa2/VS_code_Onboarding.png)

### 3.2 代码解释

CodeRider 自动识别选中代码的编程语言并生成代码解释，帮助您更高效地阅读和理解代码。

![vs_code_代码解释.png](https://jihulab.com/-/project/220417/uploads/4f10668f92701a56d5e013d34f9e4e18/vs_code_%E4%BB%A3%E7%A0%81%E8%A7%A3%E9%87%8A.png)

### 3.3 代码注释

CodeRider 为所选代码片段生成行间注释，提升代码的可读性，帮助您快速阅读代码。

![vs_code_代码注释.png](https://jihulab.com/-/project/220417/uploads/f72898648ea599b4c95a4b6d5b064127/vs_code_%E4%BB%A3%E7%A0%81%E6%B3%A8%E9%87%8A.png)

### 3.4 代码修改

CodeRider 根据您输入的代码修改指令完成对选中代码片段的修改，帮助您快速改写代码。

![vs_code_代码修改.png](https://jihulab.com/-/project/220417/uploads/7e9804d3a044333ea2a9b61dbe7973a8/vs_code_%E4%BB%A3%E7%A0%81%E4%BF%AE%E6%94%B9.png)

### 3.5 单元测试

CodeRider 为所选代码片段生成单元测试代码，帮助您准确、高效地测试函数或代码片段。

![vs_code_单元测试.png](https://jihulab.com/-/project/220417/uploads/7699e187ecbb274b402a6f7235d1f2d0/vs_code_%E5%8D%95%E5%85%83%E6%B5%8B%E8%AF%95.png)

### 3.6 代码优化

CodeRider 为所选代码片段生成改进建议及参考优化代码，以提升代码的可读性、可维护性、安全性等，帮助您生成更优美的代码。

![vs_code_代码优化.png](https://jihulab.com/-/project/220417/uploads/8bda2ad58eba71d50ce8146bb9338d01/vs_code_%E4%BB%A3%E7%A0%81%E4%BC%98%E5%8C%96.png)

## 4. 智能 DevOps 助手

### 4.1 处理议题

CodeRider 支持在议题中生成讨论内容概览，快速清晰地给出议题结论，帮助用户高效地阅读议题信息，提升工作效率。生成的议题摘要，您可以双击修改，并一键评论到议题讨论内容中，同步给当前议题的所有用户。

![VS_code_issue_处理.png](https://jihulab.com/-/project/220417/uploads/1a696b3d93e9633bf579507a8ac7e6e2/VS_code_issue_%E5%A4%84%E7%90%86.png)

### 4.2 生成提交信息

CodeRider 支持为提交的代码生成提交信息。同时，您可以设置提交信息的语言。

注：对于当前更改有且仅有新增的文件，由于无法建立跟踪，因此针对此类暂存无法生成提交信息。

![VS_Code_commit_message.png](https://jihulab.com/-/project/220417/uploads/2de751e583e687dad35aacc18b665e72/VS_Code_commit_message.png)

### 4.3 代码预审核

CodeRider 支持在提交修改代码前进行代码预审核，帮助您将代码评审前置，提交高质量的代码，提升开发效率。

注：对于新增的文件，由于无法建立跟踪，因此针对此类变更文件无法使用代码预审核。

![vs_code_代码预审核.png](https://jihulab.com/-/project/220417/uploads/ecba784763992e069ff1868b7c8e612c/vs_code_%E4%BB%A3%E7%A0%81%E9%A2%84%E5%AE%A1%E6%A0%B8.png)


### 4.4 处理合并请求

CodeRider 支持在合并请求中生成内容摘要，包含合并请求的概述、变更内容、影响范围、预期结果等。生成的合并请求摘要，您可以双击修改，并一键评论到合并请求内容中，同步给合并请求提交者。

![vs_code_MR_处理.png](https://jihulab.com/-/project/220417/uploads/f8c30093a0bdd430b6bd894d4f97152b/vs_code_MR_%E5%A4%84%E7%90%86.png)

### 4.5 文件级代码智能审核

CodeRider 支持在 IDE 中审核提交的合并请求，同时支持在 IDE 中查看合并请求修改前后的对比代码，并可添加评审建议。

CodeRider 支持文件级代码评审，即可针对当前合并请求生成逐文件级的代码评审建议，您可以双击修改，并一键将当前文件或 MR 中所有文件的评审建议评论到 MR 内容中，将评审建议同步给合并请求提交者。

![文件级代码评审.png](https://jihulab.com/-/project/220417/uploads/7791a9e90fe38c830a3c130d428a623f/%E6%96%87%E4%BB%B6%E7%BA%A7%E4%BB%A3%E7%A0%81%E8%AF%84%E5%AE%A1.png)

### 4.6 管理流水线

CodeRider 支持在 Visual Studio Code 中操作流水线，包括查看流水线状态、管理流水线、下载流水线产物、创建流水线。

![vs_code_流水线.png](https://jihulab.com/-/project/220417/uploads/ddee9af290e680049471263a392569b8/vs_code_%E6%B5%81%E6%B0%B4%E7%BA%BF.png)


### 4.7 查询和处理更多 DevOps 任务

CodeRider支持在 Visual Studio Code 中查看与用户相关的 DevOps 任务，包含查询议题、查看合并请求、查看史诗、查看代码片段、查看漏洞，同时支持自定义搜索构建独有的任务查询。

![vs_code_DevOps_配置.png](https://jihulab.com/-/project/220417/uploads/b54fc0915dcc0f9346f4738f868f38a7/vs_code_DevOps_%E9%85%8D%E7%BD%AE.png)

### 4.8 GitLab 快捷操作命令

CodeRider 支持 20 多种 GitLab 快捷操作命令，包含查看 GitLab 议题和合并请求、创建合并请求、审核合并请求、验证 CI/CD 配置、管理流水线、管理代码片段等。

![GitLab_快捷操作.png](https://jihulab.com/-/project/220417/uploads/b1076595cfa3f5c5c9e0b19136970c60/GitLab_%E5%BF%AB%E6%8D%B7%E6%93%8D%E4%BD%9C.png)


## 5. 智能问答

IDE 中可以打开“深度思考”模式，使用推理模型进行问答。

![GitLab_深度思考.png](https://jihulab.com/-/project/220417/uploads/538d04ff4191489da9c45525574d4995/v1.9.0_%E6%B7%B1%E5%BA%A6%E6%80%9D%E8%80%83.png)

### 5.1 自然语言多轮技术问答

当配置模型生效后，您可以灵活选择本地模型、云端模型、私有模型（企业私有化部署用户）来完成研发技术问答，您无需离开编程界面即可使用 CodeRider 解决研发中的技术难题。同时，CodeRider 支持多轮对话问答，能够快速响应开发人员的问题，并提供准确的解决方案。另外，当您需要针对代码片段提问时，请先将对应代码片段粘贴到对话输入框，并输入相关问题。

CodeRider 会在当前会话框首次聊天时，生成会话标题摘要。同时，支持在“历史记录”界面修改会话标题。

当对话轮次较多，需主动清除上下文时，可以在对话框中输入“/”并选择“清除记忆”来清空当前对话框中的历史内容。

![vs_code_chat.png](https://jihulab.com/-/project/220417/uploads/8d92876579188303e7e362fe7e5be4c2/vs_code_chat.png)

### 5.2 知识库问答

CodeRider 支持基于云端模型、私有模型（私有化部署企业）的企业知识库功能，拥有访客及以上权限的用户可以在对话框“@” 知识库名称，并针对知识库内容进行技术问答。

![vs_code_知识库问答.png](https://jihulab.com/-/project/220417/uploads/3d42a982c224f06e7b12c59700d508ba/vs_code_%E7%9F%A5%E8%AF%86%E5%BA%93%E9%97%AE%E7%AD%94.png)

### 5.3 企业代码问答

CodeRider 支持基于云端模型、私有模型（私有化部署企业）的企业代码问答功能，拥有访客及以上权限的用户可以在对话框“@” 代码知识库名称，并针对代码知识库内容进行技术问答。

![vs_code_代码知识库.png](https://jihulab.com/-/project/220417/uploads/44d9b68b59d99124e5ffa38a23b71508/vs_code_%E4%BB%A3%E7%A0%81%E7%9F%A5%E8%AF%86%E5%BA%93.png)

## 提交反馈 Feedback

CodeRider是您的软件生产智能工具，期待能为您带来舒适的编程体验。如果您在使用过程中有任何问题，请[联系我们](https://forum.gitlab.cn/forum.php?mod=forumdisplay&fid=17)。

CodeRider serves as your intelligent software assistant, dedicated to providing you with a comfortable coding experience. If you encounter any issues during usage, please feel free to [contact us](https://forum.gitlab.cn/forum.php?mod=forumdisplay&fid=17).

## 更多产品信息 More Information

[产品官网 Product Official Website](https://coderider.gitlab.cn/)

[产品使用手册 Product Doc](https://gitlab.cn/docs/coderider/overview/introduction.html)
